/* ########################################################################

				  if.c

   File: if.c
   Path: /home/fournigault/c/X11/xcoral-2.33/Smac/if.c
   Description: 
   Created: Tue Feb 21 12:55:48 MET 1995
   Author: Bruno Pages
   Modified: Tue Feb 21 12:55:49 MET 1995
   Last maintained by: Bruno Pages

   RCS $Revision$ $State$
   

   ########################################################################

   Note: 

   ########################################################################

   Copyright (c) : Bruno Pages

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

   ######################################################################## */



#include "If_.h"
#include "list.h"
#include "error.h"

#include "decl.h" /**/

/* fct = make_if
   info = List ** [test, iftrue, ifalse / 0] */

Instruction * make_if(l, del)
    List * l;
    int del;
{
  Instruction * result;
  List ** m = (List **) l->info;
  
  if (del) {
    DELETE(m[0]);
    DELETE(m[1]);
    if (m[2]) DELETE(m[2]);
    result = (Instruction *) 0;
  }
  else {
    Instruction * test = MAKE(m[0]);
    
    if (test == ERROR) {
      DELETE(m[1]);
      if (m[2])
	DELETE(m[2]);
      result = ERROR;
    }
    else {
      Instruction * iftrue = MAKE(m[1]);
      
      if (iftrue == ERROR)  {
	if (m[2])
	  DELETE(m[2]);
	result = ERROR;
      }
      else {
	Instruction * iffalse;
	
	if (m[2]) {
	  iffalse = MAKE(m[2]);
	  
	  result = (iffalse == ERROR)
	    ? ERROR
	    : (Instruction *) If__If(test, iftrue, iffalse);
	}
	else
	  result = (Instruction *) If__If(test, iftrue, 0);
      }
    }
  }
  
  free(l);
  free(m);
  
  return result;
}


/* fct = make_arith_if
   info = List ** [test iftrue ifalse] */

Instruction * make_arith_if(l, del)
    List * l;
    int del;
{
  List ** m = (List **) l->info;
  Instruction * result;
  
  if (del) {
    DELETE(m[0]);
    DELETE(m[1]);
    DELETE(m[2]);
    result = (Instruction *) 0;
  }
  else {
    Instruction * test = MAKE(m[0]);
    
    if (test == ERROR) {
      DELETE(m[1]);
      if (m[2])
	DELETE(m[2]);
      result = ERROR;
    }
    else {
      Instruction * iftrue = MAKE(m[1]);
      
      if (iftrue == ERROR)  {
	if (m[2])
	  DELETE(m[2]);
	result = ERROR;
      }
      else {
	Instruction * iffalse = MAKE(m[2]);
	
	result = (iffalse == ERROR)
	  ? ERROR
	  : (Instruction *) ArithIf__ArithIf(test, iftrue, iffalse);
      }
    }
  }
  
  free(l);
  free(m);
  
  return result;
}
