/* ########################################################################

			      proc_dict.c

   File: proc_dict.c
   Path: /home/fournigault/c/X11/xcoral-2.31/proc_dict.c
   Description: 
   Created: Fri Jan 27 11:25:07 MET 1995
   Author: Dominique Leveque
   Modified: Fri Jan 27 11:25:08 MET 1995
   Last maintained by: Dominique Leveque

   RCS $Revision$ $State$
   

   ########################################################################

   Note: 

   ########################################################################

   Copyright (c) : Dominique Leveque

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

   ######################################################################## */

#if HAVE_STRING_H
#include <string.h>
#else
#include <strings.h>
#endif
#include <stdio.h>

#include <stdlib.h>

#include "result_types.h"
#include "file_dict.h"
#include "proc_dict.h"
#include "browser_util.h"

/*------------------------------------------------------------------------------
//                         Le dictionnaire des procedures
//------------------------------------------------------------------------------
*/

ProcRec* proc_dict[PROC_DICT_SIZE];

int proc_count = 0;


/*------------------------------------------------------------------------------
   create the function
   warning : its _name if part of the object, never free it separately !
*/
ProcRec* create_proc(proc_name, staticp, parsed_file)
    char* proc_name;
    int staticp;
    char * parsed_file;
{
  ProcRec**  head;
  ProcRec*   current_proc;
  int        x_size;
  
  get_head_Rec(proc_name, proc_dict, PROC_DICT_SIZE, head);
  iter_Rec(proc_name, ProcRec, head, current_proc) {
    if (current_proc->_impl_file &&
	((! strcmp(parsed_file, current_proc->_impl_file->_name)) ||
	 ((! staticp) && (! (current_proc->_decl & STATIC_PROC)))))
      return current_proc;
  }
  if (current_proc == Null) {
    x_size = sizeof(ProcRec) + PROC_PLENGTH + strlen(proc_name)  + 1;
    current_proc = (ProcRec*) xmalloc(x_size);
    if (current_proc != Null) {
      create_Rec(proc_name, ProcRec, head, current_proc, PROC_PREFIX, PROC_PLENGTH);
      current_proc->_impl_file = Null;
      current_proc->_impl_line = 0;
      current_proc->_decl = 0;
      current_proc->_hide = 0;
      proc_count++;
    }
  }
  return(current_proc);
}


/*------------------------------------------------------------------------------
*/
ProcRec* find_proc(proc_name)
  char* proc_name;
{
  ProcRec**  head;
  ProcRec*   current_proc;

  get_head_Rec(proc_name, proc_dict, PROC_DICT_SIZE, head);
  assoc_Rec(proc_name, ProcRec, head, current_proc);
  return(current_proc);
}


/*------------------------------------------------------------------------------
   remove functions defined in file_name, all functions if file_name == 0
*/
void proc_eraze_file(file_name)
    char * file_name;
{
  FileRec * current_file;
  ProcRec ** pdict;
  
  if (file_name == 0)
    current_file = 0;
  else if ((current_file = find_file(file_name)) == 0)
    return;
  
  for (pdict = proc_dict;
       pdict != &proc_dict[PROC_DICT_SIZE];
       pdict += 1) {
    ProcRec ** p_proc = pdict;
    ProcRec * current_proc;
    
    while ((current_proc = *p_proc) != Null) {
      if ((current_file == 0) || (current_proc->_impl_file == current_file)) {
	/* remove it */
	*p_proc = current_proc->_next;
	proc_count -= 1;
	free(current_proc);	/* _name is part of it */
      }
      else
	/* keep it */
	p_proc = &current_proc->_next;
    }
  }
}  

/*------------------------------------------------------------------------------
*/

void proc_eraze_marked_files()
{
  ProcRec ** pdict;
  ProcRec ** head;
  ProcRec * cell;
  int n;

  remove_Rec(proc_dict, pdict, cell->_impl_file->_name == &Mark, 
	     PROC_DICT_SIZE, head, cell, n, proc_count, free);
}
